#! /usr/bin/env python

import sys
import os
try:
    libdir = os.path.abspath(os.path.join(os.path.dirname(__file__), 'lib'))
    sys.path.insert(0, libdir)
except:
    # probably running inside py2exe which doesn't set __file__
    pass

import optparse

import pyglet
import mainmenu
import game

if __name__ == '__main__':
    op = optparse.OptionParser()
    op.add_option('-W', '--width', dest='width', type='int', default=800,
                  help='width of window')
    op.add_option('-H', '--height', dest='height', type='int', default=600,
                  help='height of window')
    op.add_option('-f', '--fullscreen', dest='fullscreen', default=False,
                  action='store_true', help='use an entire screen')
    options, args = op.parse_args()

    # In case the user doesn't run in -O
    pyglet.options['gl_error_check'] = False

    window = game.GameWindow('delta-v', 
                             width=options.width, 
                             height=options.height,
                             fullscreen=options.fullscreen,
                             accum_red_size=16,
                             accum_green_size=16,
                             accum_blue_size=16,
                             vsync=False) # no vsync tears but better physics
    state = mainmenu.MainMenu()
    window.push_state(state)
    window.run()
